#include "os_dep.h"

#include <math.h>
#include <stdio.h>

#include "palette.h"

extern int calculate_screen(int);
extern void close_screen(void);

#if 0
unsigned char ec[65536];
unsigned char *ecran1=&ec[512];

char _an[100000];
char _an1[100000];

unsigned char *ecran=&_an[320*10];
unsigned char *ecran1=&_an1[320*10];
#endif

unsigned int _cosi_[512], _sini_[512];

void init_cos_sin(void)
{
  int i;
  for (i=0; i<512; i++) {
    _sini_[i]=(unsigned int)(sin(M_PI*2.*i/512.)*65536.*16.);
    _cosi_[i]=(unsigned int)(cos(M_PI*2.*i/512.)*65536.*16.);
  }
}

void boule_palette(void)
{
  #define N 2
  //char palette[256][3];
  char pre_pal[16][3]={
    {63<<N,63<<N,0<<N},
    {63<<N,59<<N,0<<N},
    {63<<N,55<<N,0<<N},
    {63<<N,51<<N,0<<N},
    {63<<N,47<<N,0<<N},
    {63<<N,43<<N,0<<N},
    {63<<N,39<<N,0<<N},
    {63<<N,35<<N,0<<N},

//    {63,31,0},
    {59<<N,27<<N,8<<N},
    {55<<N,23<<N,16<<N},
    {51<<N,19<<N,24<<N},
    {47<<N,15<<N,32<<N},
    {43<<N,11<<N,40<<N},
    {39<<N,7<<N,48<<N},
    {35<<N,3<<N,56<<N},
    {31<<N,0<<N,63<<N}
  };
  sub_palette(pre_pal, 256-16, 16);
  set_palette();
#if 0
  int i;
  for (i=0; i<16; i++) {
    int j;
    for (j=0; j<16; j++) {
      palette[i*16+j][0]=(pre_pal[j][0]*i/15)<<2;
      palette[i*16+j][1]=(pre_pal[j][1]*i/15)<<2;
      palette[i*16+j][2]=(pre_pal[j][2]*i/15)<<2;
    }
  }
  put_palette(&palette[0][0]);
#endif
}

int _ub[51];
int _uub[51];
int _uuub[51];
int col[51];
void init_bezier_boule(void)
{
  int i;
  double u;
  for (u=0, i=0; i<=50; i++, u+=0.02) {
    _ub[i]=u*(double)(1<<10);
    _uub[i]=(u*u)*(double)(1<<10);
    _uuub[i]=(u*u*u)*(double)(1<<10);
    col[i]=15.-u*15.;
  }
}

void bezier_boule(void)
{
  extern int pts_tab[5][2];
  int i;
  //  double u;
  int x, y;
  int ax=(-pts_tab[0][0]+3*pts_tab[1][0]-3*pts_tab[2][0]+pts_tab[3][0]);
  int bx=(3*pts_tab[0][0]-6*pts_tab[1][0]+3*pts_tab[2][0]);
  int cx=(-3*pts_tab[0][0]+3*pts_tab[1][0]);
  int dx=pts_tab[0][0];
  int ay=(-pts_tab[0][1]+3*pts_tab[1][1]-3*pts_tab[2][1]+pts_tab[3][1]);
  int by=(3*pts_tab[0][1]-6*pts_tab[1][1]+3*pts_tab[2][1]);
  int cy=(-3*pts_tab[0][1]+3*pts_tab[1][1]);
  int dy=pts_tab[0][1];
  for (i=0; i<5; i++)
    if (pts_tab[i][0]<0 || pts_tab[i][0]>319 || pts_tab[i][1]<0 || pts_tab[i][1]>199)
      return;

  for (i=0; i<=50; i++) {
    x=(_uuub[i])*ax;
    x+=(_uub[i])*bx;
    x+=_ub[i]*cx;
    x>>=10;
    x+=dx;
    y=(_uuub[i])*ay;
    y+=(_uub[i])*by;
    y+=_ub[i]*cy;
    y>>=10;
    y+=dy;
    *(ecran1+y*320+x)=col[i]+0xf0;
  }
}

int boule_main(void)
{
#if 0
  int nb_screen=0;
  int lastscreen=0;
  double time=0;
#endif
  init_bezier_boule();
  init_cos_sin();
  //init_screen();
  boule_palette();
  init_screen_head();
#if 0
  reset_timer(40.*1000.);
  while(time<1.) {
    int newscreen=time*450.*3.;
    calculate_screen(newscreen-lastscreen);
    put_screen();
    lastscreen=newscreen;
    time=get_time();
    nb_screen++;
  }
  printf("%d\n", nb_screen);
#endif
  return 0;
}
