/* this file is public domain */

#include "cube.h"

#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "fillpoly.h"

#define SMALL	(1.)/*(0.5)*/

/* when you see those globals, you are very allowed to think i began to have hard work
 * with all those angles, rotations, faces and so on. I am definitly not a good graphical
 * coder. Am i a good coder in something anyway ?
 */
int nb_facettes;
typedef struct {
  double z;
  int x0, y0, x1, y1, x2, y2, x3, y3;
  int col;
} facette;

facette f[6];
int order[6];

void init_cube(void)
{
  int i;

  for (i=0; i<6; i++)
    order[i]=i;
}

void mulm(double a[3][3], double b[3][3])
{
  int i, j;
  double r[3][3];

  for (i=0; i<3; i++)
    for (j=0; j<3; j++)
      r[i][j]=(a[i][0]*b[0][j]+a[i][1]*b[1][j]+a[i][2]*b[2][j]);
  memcpy(a, r, 3*3*sizeof(double));
}

void xmat(double x, double m[3][3])
{
  double p[3][3]={{1.,0,0},
		 {0,cos(x),sin(x)},
		 {0,-sin(x),cos(x)}};
  mulm(m, p);
}

void ymat(double y, double m[3][3])
{
  double p[3][3]={{cos(y),0,-sin(y)},
		 {0,1.,0},
		 {sin(y),0,cos(y)}};
  mulm(m, p);
}

void zmat(double z, double m[3][3])
{
  double p[3][3]={{cos(z),sin(z),0},
		 {-sin(z),cos(z),0},
		 {0,0,1}};
  mulm(m, p);
}

void clear_facette(void)
{
  nb_facettes=0;
}

void put_facette(double z, int x0, int y0, int x1, int y1, int x2, int y2, int x3, int y3, int color)
{
  int i=nb_facettes++;
  f[i].z=z;
  f[i].x0=x0;
  f[i].y0=y0;
  f[i].x1=x1;
  f[i].y1=y1;
  f[i].x2=x2;
  f[i].y2=y2;
  f[i].x3=x3;
  f[i].y3=y3;
  f[i].col=color;
}

void tri_facette(void)
{
  /* hehe, the very first time of my i use this gcc feature, the inline function ! Crazy */
  int cmp(const void *u1, const void *u2) {
    double z1=f[*(int *)u1].z, z2=f[*(int *)u2].z;
    if (z1<z2)
      return -1;
    return z1>z2;
  }
  qsort(order, nb_facettes, sizeof(int), cmp);
}

void show_facette(int fill)
{
  int i;

  for(i=0; i<nb_facettes; i++)
    if (fill) {
      fill_triangle_8bpp(f[order[i]].x0, f[order[i]].y0, f[order[i]].x1, f[order[i]].y1,
			 f[order[i]].x2, f[order[i]].y2, f[order[i]].col);
      fill_triangle_8bpp(f[order[i]].x0, f[order[i]].y0, f[order[i]].x2, f[order[i]].y2,
			 f[order[i]].x3, f[order[i]].y3, f[order[i]].col);
    } else {
      putline_8bpp(f[order[i]].x0, f[order[i]].y0, f[order[i]].x1, f[order[i]].y1, 0);
      putline_8bpp(f[order[i]].x2, f[order[i]].y2, f[order[i]].x1, f[order[i]].y1, 0);
      putline_8bpp(f[order[i]].x2, f[order[i]].y2, f[order[i]].x3, f[order[i]].y3, 0);
      putline_8bpp(f[order[i]].x0, f[order[i]].y0, f[order[i]].x3, f[order[i]].y3, 0);
    }
}

void display_piti_cube(double a, double b, double c) //piti_cube *c, CUBE *big, int me)
{
  double m1[3][3]={{1, 0, 0}, {0, 1, 0}, {0, 0, 1}};
  double p[8][3]={{SMALL * -1, SMALL * -1, SMALL * -1}, /* 0 */
		 {SMALL * -1, SMALL * -1, SMALL *  1}, /* 1 */
		 {SMALL * -1, SMALL *  1, SMALL * -1}, /* 2 */
		 {SMALL * -1, SMALL *  1, SMALL *  1}, /* 3 */
		 {SMALL *  1, SMALL * -1, SMALL * -1}, /* 4 */
		 {SMALL *  1, SMALL * -1, SMALL *  1}, /* 5 */
		 {SMALL *  1, SMALL *  1, SMALL * -1}, /* 6 */
		 {SMALL *  1, SMALL *  1, SMALL *  1}};/* 7 */
  static int face[6][4]={{0,4,5,1},
			 {2,3,7,6},
			 {0,1,3,2},
			 {4,6,7,5},
			 {1,5,7,3},
			 {0,2,6,4}};
  double p1[8][3];
  double pp[8][2];
  int n;

  xmat(a, m1);
  ymat(b, m1);
  zmat(c, m1);

  for (n=0; n<8; n++) {
    p1[n][0]=(((p[n][0])*m1[0][0]+ (p[n][1])*m1[1][0]+ (p[n][2])*m1[2][0]));
    p1[n][1]=(((p[n][0])*m1[0][1]+ (p[n][1])*m1[1][1]+ (p[n][2])*m1[2][1]));
    p1[n][2]=(((p[n][0]/*+c->x*/)*m1[0][2]+ (p[n][1]/*+c->y*/)*m1[1][2]+ (p[n][2]/*+c->z*/)*m1[2][2]));
    #define x (p1[n][0])
    #define y (p1[n][1])
    #define z (p1[n][2])
    #define Xp (pp[n][0])
    #define Yp (pp[n][1])
    Xp=320/2+320/2*x/(5*(1)-z);
    Yp=100-/*200./(2.*200./320.)*/120.*y/(5*(1)-z);
    #undef x
    #undef y
    #undef z
    #undef Xp
    #undef Yp
  }

  for (n=0; n<6; n++) {
    double zm=p1[face[n][0]][2]+p1[face[n][1]][2]+p1[face[n][2]][2]+p1[face[n][3]][2];
    put_facette(zm, pp[face[n][0]][0], pp[face[n][0]][1], pp[face[n][1]][0], pp[face[n][1]][1], 
		pp[face[n][2]][0], pp[face[n][2]][1], pp[face[n][3]][0], pp[face[n][3]][1], n+16*3);
  }
}

void display_cube(double a, double b, double c, int fill)
{
  clear_facette();

  display_piti_cube(a, b, c);

  tri_facette();
  show_facette(fill);
}
