/* this file is public domain */

#ifndef _CUBE_H_
#define _CUBE_H_

/* init pos. all angles=0.
        x25    x22    x20                               x 1
      x24           x19
    x23    x21    x18(                                         x 5

        x17           x15
                                               x 2               x 3
    x16           x14
                                                    x 4
        x13    x10    x8(1, -1, -1)
      x12           x7
    x11    x9     x6                                    x 0
 (-1, -1, 1)     (1, -1, 1)
      -------------------------------->X
     |      y                                    x2               x6
     |      |
     |      |                              x3               x7
     |      |
     |      |
     |       -------x
     |     /(160,120)
     |    /                                      x0               x4
     |   /
     |  z                                  x1               x5
     |
     V
     Y                           0                            319
                      y           ---------------------------->x
                      ^          -1                            1
                      |          
                      |         1|0
                      |          |              .(X, Y)
               ^      |          |
              1|      |          |
               |      |        -1|239
z <------.------------           v
         2     1

(2-1)/(2-z)=Y/y
(2-1)/(2-z)=X/x

(2-1)/(2-z)*y=Y
(2-1)/(2-z)*x=X

319/Xp=2/(X+1)       =>  Xp=319/2*(X+1)
239/Yp=-2/(Y-1)      =>  Yp=-239/2*(Y-1)
*/


void init_cube(void);
void display_cube(double, double, double, int);

#endif /* _CUBE_H_ */
