/*
 * donut : a little donut.
 * Done for Digital Murder's second demo.
 *
 * Sed - january 1999
 *
 * This is total free software (but is it only a software ?)
 *
 * donut stuff.
 */

#include "donut.h"

#include "point.h"
#include "fixed_math.h"
#include "fillpoly.h"

#include <math.h>
#include <stdlib.h>

#define SYNC	11

int nb_points;

void create_donut(point *the_points, facette *f, int nbx, int nby)
{
  /* let's create the donut */
#define r 1.5
#define R 5
  int i, j, k=0, l, col=1;
  for (i=0; i<nbx; i++)
    for (j=0; j<nby; j++) {
      the_points[k].x=((R+r*cos(j*M_PI*2./nby))*cos(i*2.*M_PI/nbx))*1024.;
      the_points[k].y=(r*sin(j*2.*M_PI/nby))*1024.;
      the_points[k++].z=((R+r*cos(j*M_PI*2./nby))*sin(i*2.*M_PI/nbx))*1024.;
    }
  nb_points=nbx*nby;
  for (i=0; i<nb_points; i++) {
    j=((i+1)&7)+(i&~7);
    k=(i+8)&63;
    l=((k+1)&7)+(k&~7);
    f[i].p1=i;
    f[i].p2=j;
    f[i].p3=k;
    f[i].p4=l;
    f[i].color1=col++;
    f[i].color2=col++;
  }
  /* let's create the sexe */
#define Q (5<<10)
#define X1	(-.2*Q)
#define X2	(.2 *Q)
#define Y1	(-1 *Q)
#define Y2	(1  *Q)
#define Z1	(-.2*Q)
#define Z2	(.2 *Q)

#define P1 nb_points
#define P2 P1+1
#define P3 P1+2
#define P4 P1+3
#define P5 P1+4
#define P6 P1+5
#define P7 P1+6
#define P8 P1+7

  the_points[P1].x=X1;
  the_points[P1].y=Y1;
  the_points[P1].z=Z1;

  the_points[P2].x=X1;
  the_points[P2].y=Y1;
  the_points[P2].z=Z2;

  the_points[P3].x=X1;
  the_points[P3].y=Y2;
  the_points[P3].z=Z1;

  the_points[P4].x=X1;
  the_points[P4].y=Y2;
  the_points[P4].z=Z2;

  the_points[P5].x=X2;
  the_points[P5].y=Y1;
  the_points[P5].z=Z1;

  the_points[P6].x=X2;
  the_points[P6].y=Y1;
  the_points[P6].z=Z2;

  the_points[P7].x=X2;
  the_points[P7].y=Y2;
  the_points[P7].z=Z1;

  the_points[P8].x=X2;
  the_points[P8].y=Y2;
  the_points[P8].z=Z2;

#define F1 nb_points
#define F2 F1+1
#define F3 F1+2
#define F4 F1+3
#define F5 F1+4
#define F6 F1+5
  f[F1].p1=P1; f[F1].p2=P2; f[F1].p3=P3; f[F1].p4=P4; f[F1].color1=col; f[F1].color2=col;
  f[F2].p1=P2; f[F2].p2=P1; f[F2].p3=P6; f[F2].p4=P5; f[F2].color1=col+1; f[F2].color2=col+1;
  f[F3].p1=P2; f[F3].p2=P6; f[F3].p3=P4; f[F3].p4=P8; f[F3].color1=col; f[F3].color2=col;
  f[F4].p1=P6; f[F4].p2=P5; f[F4].p3=P8; f[F4].p4=P7; f[F4].color1=col; f[F4].color2=col;
  f[F5].p1=P1; f[F5].p2=P3; f[F5].p3=P5; f[F5].p4=P7; f[F5].color1=col; f[F5].color2=col;
  f[F6].p1=P3; f[F6].p2=P4; f[F6].p3=P7; f[F6].p4=P8; f[F6].color1=col; f[F6].color2=col;

  /* the ejaculation points */
  for (i=nb_points+8; i<nb_points+8+32; i++) {
    the_points[i].x=((40.0*rand()/(RAND_MAX+1.0))-20.)*(5<<10)/100;
    the_points[i].z=((40.0*rand()/(RAND_MAX+1.0))-20.)*(5<<10)/100;
  }
  for (i=nb_points+6; i<nb_points+6+32; i++) {
    f[i].p1=i+2;
    f[i].p2=-1;
  }
}

void position_points(point *the_points, int a1, int a2, int a3)
{
  int i;

  prepare_matrix(a1, a2, a3);
  for (i=0; i<nb_points; i++) {
#if 0
    the_points[i].xp=the_points[i].x;
    the_points[i].yp=the_points[i].y;
    the_points[i].zp=the_points[i].z;
#endif
    positionne_one_point(&the_points[i]);
  }
}

void projete_points(point *the_points)
{
  int i;

  for (i=0; i<nb_points; i++)
    projete_one_point(&the_points[i]);
}

int comp_facette(const void *f1, const void *f2)
{
  return ((facette *)f1)->z>((facette *)f2)->z;
}

void draw_facettes(point *p, facette *f)
{
  int i;
  /* calculate their average z */
  for (i=0; i<nb_points; i++) {
    f[i].z=p[f[i].p1].zp+p[f[i].p3].zp;
  }
  /* sort the facettes */
  qsort(f, nb_points, sizeof(facette), comp_facette);
  for (i=0; i<nb_points; i++) {
    fill_triangle_8bpp(p[f[i].p1].X, p[f[i].p1].Y, p[f[i].p2].X, p[f[i].p2].Y, p[f[i].p3].X, p[f[i].p3].Y, f[i].color1);
    fill_triangle_8bpp(p[f[i].p2].X, p[f[i].p2].Y, p[f[i].p4].X, p[f[i].p4].Y, p[f[i].p3].X, p[f[i].p3].Y, f[i].color2);
  }
}

void position_points_sexe(point *the_points, int a1, int a2, int a3, int nb)
{
  extern int sin_tab[512];
  int i;

  prepare_matrix(a1, a2, a3);
  the_points[P1].y=
    the_points[P2].y=
    the_points[P5].y=
    the_points[P6].y=(Y1)+(sin_tab[(nb*SYNC)&511]*2);
  the_points[P3].y=
    the_points[P4].y=
    the_points[P7].y=
    the_points[P8].y=(Y2)+(sin_tab[(nb*SYNC)&511]*2);
  for (i=0; i<nb_points+8; i++)
    positionne_one_point(&the_points[i]);
}

void projete_points_sexe(point *the_points)
{
  int i;

  for (i=0; i<nb_points+8; i++)
    projete_one_point(&the_points[i]);
}

void draw_facettes_sexe(point *p, facette *f)
{
  int i;
  /* calculate their average z */
  for (i=0; i<nb_points+6; i++) {
    f[i].z=p[f[i].p1].zp+p[f[i].p3].zp+p[f[i].p2].zp+p[f[i].p4].zp;
  }
  /* sort the facettes */
  qsort(f, nb_points+6, sizeof(facette), comp_facette);
  for (i=0; i<nb_points+6; i++) {
    fill_triangle_8bpp(p[f[i].p1].X, p[f[i].p1].Y, p[f[i].p2].X, p[f[i].p2].Y, p[f[i].p3].X, p[f[i].p3].Y, f[i].color1);
    fill_triangle_8bpp(p[f[i].p2].X, p[f[i].p2].Y, p[f[i].p4].X, p[f[i].p4].Y, p[f[i].p3].X, p[f[i].p3].Y, f[i].color2);
  }
}

void position_points_ejacule(point *the_points, int a1, int a2, int a3, int nb)
{
  extern int sin_tab[512];
  int i;

  prepare_matrix(a1, a2, a3);
  the_points[P1].y=
    the_points[P2].y=
    the_points[P5].y=
    the_points[P6].y=(Y1)+(sin_tab[(nb*SYNC)&511]*2);
  the_points[P3].y=
    the_points[P4].y=
    the_points[P7].y=
    the_points[P8].y=(Y2)+(sin_tab[(nb*SYNC)&511]*2);
  for (i=0; i<nb_points+8; i++)
    positionne_one_point(&the_points[i]);
  for (;i<nb_points+8+32; i++) {
    the_points[i].y=the_points[P1].y-(200.0*rand()/(RAND_MAX+1.0))*32;
    positionne_one_point(&the_points[i]);
  }
}

void projete_points_ejacule(point *the_points)
{
  int i;

  for (i=0; i<nb_points+8+32; i++)
    projete_one_point(&the_points[i]);
}

void draw_facettes_ejacule(point *p, facette *f, int nb)
{
  int i;
  /* calculate their average z */
  for (i=0; i<nb_points+6+32; i++) {
    if (f[i].p2!=-1)
      f[i].z=p[f[i].p1].zp+p[f[i].p3].zp+p[f[i].p2].zp+p[f[i].p4].zp;
    else
      f[i].z=p[f[i].p1].zp*4;
  }
  /* sort the facettes */
  qsort(f, nb_points+6+32, sizeof(facette), comp_facette);
  for (i=0; i<nb_points+6+32; i++) {
    if (f[i].p2!=-1) {
      fill_triangle_8bpp(p[f[i].p1].X, p[f[i].p1].Y, p[f[i].p2].X, p[f[i].p2].Y, p[f[i].p3].X, p[f[i].p3].Y, f[i].color1);
      fill_triangle_8bpp(p[f[i].p2].X, p[f[i].p2].Y, p[f[i].p4].X, p[f[i].p4].Y, p[f[i].p3].X, p[f[i].p3].Y, f[i].color2);
    } else if (!(nb&32)) {
      int pos;
      extern char *ecran1;
      if (p[f[i].p1].Y>=0 && p[f[i].p1].Y<200 && p[f[i].p1].X>0 && p[f[i].p1].X<320) {
	pos=p[f[i].p1].Y*320+p[f[i].p1].X;
	ecran1[pos]=ecran1[pos-1]=ecran1[pos+1]=ecran1[pos-320]=ecran1[pos+320]=131;
      }
    }
  } 
#if 0
  for (i=nb_points+8; i<nb_points+8+32; i++) {
    int pos;
    extern char *ecran1;
    if (p[i].Y>=0 && p[i].Y<200 && p[i].X>0 && p[i].X<320) {
      pos=p[i].Y*320+p[i].X;
      ecran1[pos]=ecran1[pos-1]=ecran1[pos+1]=ecran1[pos-320]=ecran1[pos+320]=131;
    }
  }
#endif
}
