/*
 * donut : a little donut.
 * Done for Digital Murder's second demo.
 *
 * Sed - january 1999
 *
 * This is total free software (but is it only a software ?)
 *
 * fixed_math stuff (no float, all in int).
 */

#include "fixed_math.h"

#include "point.h"

#include <math.h>

int sin_tab[512];
int cos_tab[512];

int m[3][3];

void init_math(void)
{
  int i;
  for (i=0; i<512; i++) {
    sin_tab[i]=sin(M_PI*2.*i/512.)*1024.;
    cos_tab[i]=cos(M_PI*2.*i/512.)*1024.;
  }
}

void prepare_matrix(int a1, int a2, int a3)
{
  /* rotation x (a1), then y (a2), then z (a3) */
  /*
    rot a1 => :
    nx=x
    ny=z*sin_tab[a1]+y*cos_tab[a1]
    nz=z*cos_tab[a1]-y*sin_tab[a1]

    rot a2 => :
    ox=nx*cos_tab[a2]-nz*sin_tab[a2]
    oy=ny
    oz=nx*sin_tab[a2]+nz*cos_tab[a2]

    rot a3 => :
    px=oy*sin_tab[a3]+ox*cos_tab[a3]
    py=oy*cos_tab[a3]-ox*sin_tab[a3]
    pz=oz

    =>
    ox=x*cos_tab[a2]-z*cos_tab[a1]*sin_tab[a2]+y*sin_tab[a1]*sin_tab[a2]
    oy=z*sin_tab[a1]+y*cos_tab[a1]
    oz=x*sin_tab[a2]+z*cos_tab[a1]*cos_tab[a2]-y*sin_tab[a1]*cos_tab[a2]

    =>
    px=(z*sin_tab[a1]+y*cos_tab[a1])*sin_tab[a3]+
       (x*cos_tab[a2]-z*cos_tab[a1]*sin_tab[a2]+y*sin_tab[a1]*sin_tab[a2])*cos_tab[a3]
    py=(z*sin_tab[a1]+y*cos_tab[a1])*cos_tab[a3]-
       (x*cos_tab[a2]-z*cos_tab[a1]*sin_tab[a2]+y*sin_tab[a1]*sin_tab[a2])*sin_tab[a3]
    pz=x*sin_tab[a2]+z*cos_tab[a1]*cos_tab[a2]-y*sin_tab[a1]*cos_tab[a2]

    =>
  */
  m[0][0]=(cos_tab[a2]*cos_tab[a3])>>10;
  m[0][1]=((cos_tab[a1]*sin_tab[a3])>>10)+((sin_tab[a1]*sin_tab[a2]*cos_tab[a3])>>20);
  m[0][2]=((sin_tab[a1]*sin_tab[a3])>>10)-((cos_tab[a1]*sin_tab[a2]*cos_tab[a3])>>20);

  m[1][0]=(-cos_tab[a2]*sin_tab[a3])>>10;
  m[1][1]=((cos_tab[a1]*cos_tab[a3])>>10)-((sin_tab[a1]*sin_tab[a2]*sin_tab[a3])>>20);
  m[1][2]=((sin_tab[a1]*cos_tab[a3])>>10)+((cos_tab[a1]*sin_tab[a2]*sin_tab[a3])>>20);

  m[2][0]=sin_tab[a2];
  m[2][1]=(-sin_tab[a1]*cos_tab[a2])>>10;
  m[2][2]=(cos_tab[a1]*cos_tab[a2])>>10;
}

void positionne_one_point(point *p)
{
  p->xp=(m[0][0]*p->x+m[0][1]*p->y+m[0][2]*p->z)>>10;
  p->yp=(m[1][0]*p->x+m[1][1]*p->y+m[1][2]*p->z)>>10;
  p->zp=((m[2][0]*p->x+m[2][1]*p->y+m[2][2]*p->z)>>10);
}

void projete_one_point(point *p)
{
#define Z 11
#define L 1
  p->X=160+160*p->xp/(((Z<<10)+(L<<10))-p->zp);
  p->Y=100-120*p->yp/(((Z<<10)+(L<<10))-p->zp); /*160=200*.8*/
}
