/* des routines os dependantes (a la base, c'est linux, dos a voir (djgpp...)) */

extern void new_wait_retrace(void);
extern void new_put_palette(unsigned char *);
extern void new_put_screen(void);

char *screen;

#include "os_dep.h"

/**********************************
 * Section 1 : les routines ecran *
 **********************************/

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include <stdio.h>
#include <unistd.h>

Display *X_ecran;
Colormap map;
Window la_win;
GC gcontext;
XImage *X_image;

int svga=0;

/* retourne 0 si pb 1 sinon */
int init_screen(void)
{
  X_ecran=XOpenDisplay(0);
    
  if (!X_ecran) svga=1;
    
  if (!svga) {
    XSetWindowAttributes attributs;
    XGCValues gcv;
    XEvent ev;
    XColor a;
    Pixmap p;
    GC pixgc;

    map=XCreateColormap(X_ecran, DefaultRootWindow(X_ecran), DefaultVisual(X_ecran, DefaultScreen(X_ecran)), AllocAll);
    attributs.colormap=map;
    p=XCreatePixmap(X_ecran, DefaultRootWindow(X_ecran), 1, 1, 1);
    pixgc=XCreateGC(X_ecran, p, 0, 0);
    a.red=a.green=a.blue=0;
    XFillRectangle(X_ecran, p, pixgc, 0, 0, 100, 100);
    XFreeGC(X_ecran, pixgc);
    attributs.cursor=XCreatePixmapCursor(X_ecran, p, p, &a, &a, 0, 0);
    XFreePixmap(X_ecran, p);
    la_win=XCreateWindow(X_ecran, DefaultRootWindow(X_ecran), 0, 0, 320, 200, 3, 8, CopyFromParent, CopyFromParent,
			 CWColormap|CWCursor, &attributs);
    XSelectInput(X_ecran, la_win, KeyPressMask|ExposureMask);
    XMapWindow(X_ecran, la_win);
    do
      XNextEvent(X_ecran, &ev);
    while (ev.type!=Expose || ev.xexpose.window!=la_win);
    gcv.function=GXcopy;
    gcontext=XCreateGC(X_ecran,la_win,GCFunction,&gcv);
    
    /* bitmap_pad, what the heck is it ?? mail p6mip300@infop6.cicrp.jussieu.fr if you know, please... */
    X_image=XCreateImage(X_ecran, DefaultVisual(X_ecran, DefaultScreen(X_ecran)), 8, ZPixmap, 0, ecran1, 320, 200, 8, 0);
    return 1;
  } else {
    vga_init();
    vga_setmode(G320x200x256);
    screen=vga_getgraphmem();
    sleep(3);
    return 1;
  }
}

void close_screen(void)
{
  if (!svga) {
    XDestroyWindow(X_ecran, la_win);
  } else {
    vga_setmode(TEXT);
  }
}

void wait_retrace(void)
{
  if (!svga)
    return;
  new_wait_retrace();
}

void put_screen(void)
{
  if (!svga) {
    XPutImage(X_ecran, la_win, gcontext, X_image,0,0,0,0,
	      X_image->width, X_image->height);
    XFlush(X_ecran);
  } else
    new_put_screen();
}

#include <X11/keysym.h>
#include <X11/Xutil.h>

int escape_pressed(void)
{
  if (!svga) {
    XEvent X_event;
    char buffer[15];
    KeySym key;
    XComposeStatus compose;
    if (XCheckWindowEvent(X_ecran, la_win, KeyPressMask, &X_event)) {
      XLookupString(&X_event.xkey, buffer, 10, &key, &compose);
      if (key==XK_Escape) return 1;
    }
    return 0;
  } else {
    return 0;
  }
}

void put_palette(unsigned char pal[256][3])
{
#define N 8
  if (!svga) {
    XColor color[256];
    int i;
    for (i=0; i<256; i++) {
      color[i].pixel=i;
      color[i].flags=DoRed|DoGreen|DoBlue;
      color[i].red=((unsigned int)pal[i][0])<<N;
      color[i].green=((unsigned int)pal[i][1])<<N;
      color[i].blue=((unsigned int)pal[i][2])<<N;
    }
    XStoreColors(X_ecran, map, color, 256);
    XFlush(X_ecran);
  } else {
    int i;
    unsigned char p[256][3];
    unsigned char *q=&p[0][0], *r=&pal[0][0];
    for (i=0; i<256*3; i++, q++, r++)
      *q=*r>>2;
    new_put_palette(&p[0][0]);
    asm("":::"eax", "ecx", "edx", "esi");
  }
}

#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include <stdio.h>

#if 0
/**********************************
 * Section 2 : les routines timer *
 **********************************/

#include <signal.h>
#include <sys/time.h>
#include <stdio.h>

/* on utilise un timer, on fait des pauses entre les screens */
/* les signaux POSIX, wooooo */

int nb_screen;

void timer(int n)
{
  nb_screen++;
}

/* 0 si pb 1 sinon */
int init_timer(int x)
{
  struct sigaction act;
  struct itimerval tim;

  nb_screen=0;

  act.sa_handler=timer;
  sigemptyset(&act.sa_mask);
  act.sa_flags=0;
  act.sa_restorer=0;
  if(sigaction(SIGALRM, &act, (struct sigaction *)0)==-1) {
    fprintf(stderr, "erreur avec sigaction, sorry...\n");
    return 0;
  }

  tim.it_interval.tv_sec=0;
  tim.it_interval.tv_usec=1000000/x;
  tim.it_value.tv_sec=0;
  tim.it_value.tv_usec=1000000/x;
  if(setitimer(ITIMER_REAL, &tim, (struct itimerval *)0)==-1) {
    fprintf(stderr, "erreur avec setitimer, sorry...\n");
    return 0;
  }

  return 1;
}

int tour=1;
void change_timer(void)
{
  if (tour) {
    struct itimerval tim;
    tim.it_interval.tv_sec=0;
    tim.it_interval.tv_usec=10*1000;
    tim.it_value.tv_sec=0;
    tim.it_value.tv_usec=10*1000;
    setitimer(ITIMER_REAL, &tim, (struct itimerval *)0);
  } else {
    struct itimerval tim;
    tim.it_interval.tv_sec=0;
    tim.it_interval.tv_usec=40*1000;
    tim.it_value.tv_sec=0;
    tim.it_value.tv_usec=40*1000;
    setitimer(ITIMER_REAL, &tim, (struct itimerval *)0);
  }
  tour++;
  tour&=1;
}

void close_timer(void)
{
  /* rien a faire, on va quitter juste apres, le process va et' kille
   * linux nettoie pour nous :)
   */
}

/* un wait a la posix, on bloque tous les signaux, on teste si ecran=0,
 * si oui, on fait un sigsuspend, sinon on remet les signaux et on retourne
 * ecran
 * retourne le nb d'ecran a sauter (-1 en fait, vu que ca rend 1 au min)
 */
int wait_timer(void)
{
  sigset_t act;
  int ret;

  sigemptyset(&act);
  sigaddset(&act, SIGALRM);
  sigprocmask(SIG_BLOCK, &act, (sigset_t *)0);

  if (nb_screen==0) {
    sigset_t t;
    sigemptyset(&t);
    sigsuspend(&t);
  }

  ret=nb_screen;
  nb_screen=0;

  sigprocmask(SIG_UNBLOCK, &act, (sigset_t *)0);

  return ret;
}
#endif

#include <sys/time.h>
#include <unistd.h>

struct timeval os_dep_time;
double time_size;

double ttod(struct timeval t)
{
  return (double)t.tv_sec*1000.0+(double)t.tv_usec/1000.0;
}

void reset_timer(double time)
{
  time_size=time;
  if (gettimeofday(&os_dep_time, (struct timezone *)0)==-1) {
    perror("huh huh, gettimeofday (first) returned this error");
    fprintf(stderr, "Sorry, but no time, no demo. Hope you understand...\n");
    exit(-1);
  }
}

double get_time(void)
{
  struct timeval t;

  if (gettimeofday(&t, (struct timezone *)0)==-1) {
    perror("huh huh, gettimeofday (second) returned this error");
    fprintf(stderr, "Sorry, but no time, no demo. Hope you understand...\n");
    exit(-1);
  }

  return (ttod(t)-ttod(os_dep_time))/time_size;
}

void pause_me(double t)
{
  double d;
  reset_timer(t);
  while((d=get_time())<1.);
}
