/* this file is public domain */

#include "palette.h"

#include <string.h>

#include "os_dep.h"

static unsigned char pal[256][3];
static unsigned char pal_save[256][3];

void reset_palette(void)
{
  memset(pal, 0, 256*3);
}

void sub_palette(char *sp, int first, int nb)
{
  memcpy(&pal[first][0], sp, nb*3);
}

void set_palette(void)
{
  put_palette(pal);
}

void save_palette(void)
{
  memcpy(pal_save, pal, 256*3);
}

void restore_palette(void)
{
  memcpy(pal, pal_save, 256*3);
}

void fade_palette(unsigned char red, unsigned char green, unsigned char blue, double dt, int start, int end)
{
  int i;

  /* bad "for" code, should use memcpy */
  for (i=0; i<start; i++) {
    pal[i][0]=pal_save[i][0];
    pal[i][1]=pal_save[i][1];
    pal[i][2]=pal_save[i][2];
  }
  for (i=start; i<=end; i++) {
    pal[i][0]=(1.-dt)*(double)red   + dt*(double)pal_save[i][0];
    pal[i][1]=(1.-dt)*(double)green + dt*(double)pal_save[i][1];
    pal[i][2]=(1.-dt)*(double)blue  + dt*(double)pal_save[i][2];
  }
  /* bad "for" code, should use memcpy */
  for (i=end+1; i<256; i++) {
    pal[i][0]=pal_save[i][0];
    pal[i][1]=pal_save[i][1];
    pal[i][2]=pal_save[i][2];
  }
}

void uni_palette(unsigned char a, unsigned char b, unsigned char c)
{
  int i;
  for (i=0; i<256; i++) {
    pal[i][0]=a;
    pal[i][1]=b;
    pal[i][2]=c;
  }
}
