/* this file is public domain */

#include "sub_parts.h"

#include <stdio.h>

#include "image.h"
#include "palette.h"
#include "os_dep.h"
#include "parts.h"

/* return 0 if ok, -1 if not */
int sub_show(char *n, int x, int y, int b, int e, int add)
{
  double time=0;
  image im;
  int i, j;
  unsigned char *p;

  if (load_image(&im, n)==-1) {
    fprintf(stderr, "mmm, I can't load %s in sub_show3\n", n);
    return -1;
  }
  p=im.data;
  for (i=0; i<im.width; i++)
    for (j=0; j<im.height; j++)
      *p++ +=add;
#ifdef DEBUG
  {
    int i;
    for (i=0; i<16; i++)
      fprintf(stderr, "%2.2d = %3.3d %3.3d %3.3d\n", i, (unsigned char)im.palette[i*3+0],
	      (unsigned char)im.palette[i*3+1], (unsigned char)im.palette[i*3+2]);
  }
#endif
  sub_palette(im.palette, b, e-b+1);
  save_palette();
  fade_palette(255, 255, 255, 0, b, e);
  set_palette();
  put_image(&im, x, y);
  put_screen();
  reset_timer(1.0*1000.0);
  while(time<1.) {
    fade_palette(255, 255, 255, time, b, e);
    set_palette();
    time=get_time();
  }
  restore_palette();
  free_image(&im);
  return 0;
}

/* return 0 if ok, -1 if not */
int show2(char *n1, int x1, int y1, char *n2, int x2, int y2, char back)
{
  uni_palette(255, 255, 255);
  save_palette();
  set_palette();
  clear_screen(back);
  if (sub_show(n1, x1, y1, 0, 15, 0)==-1 || sub_show(n2, x2, y2, 16, 31, 16)==-1)
    return -1;
  return 0;
}

/* return 0 if ok, -1 if not */
int show3(char *n1, int x1, int y1, char *n2, int x2, int y2, char *n3, int x3, int y3, char back)
{
  uni_palette(255, 255, 255);
  save_palette();
  set_palette();
  clear_screen(back);
  if (sub_show(n1, x1, y1, 0, 15, 0)==-1 || sub_show(n2, x2, y2, 16, 31, 16)==-1 || sub_show(n3, x3, y3, 32, 47, 32)==-1)
    return -1;
  return 0;
}

/* return 0 if ok, -1 if not */
int show4(char *n1, int x1, int y1, char *n2, int x2, int y2, char *n3, int x3, int y3, char *n4, int x4, int y4, char back)
{
  uni_palette(255, 255, 255);
  save_palette();
  set_palette();
  clear_screen(back);
  if (sub_show(n1, x1, y1, 0, 15, 0)==-1 || sub_show(n2, x2, y2, 16, 31, 16)==-1
      || sub_show(n3, x3, y3, 32, 47, 32)==-1 || sub_show(n4, x4, y4, 48, 48+15, 48)==-1)
    return -1;
  return 0;
}
